/*
 * VTfundecl.h
 * VT routine declarations
 *
 */

#ifndef VTFUNDECL_H
#define VTFUNDECL_H

#ifdef __cplusplus
extern "C" {
#endif /* __cplusplus */

#include "std.h"
#include "dvstd.h"


/***
*** 
***/




/* VT/VThashtab.c */
ADDRESS VThtsizecreate V_P_((char *table_name,
			     VTHTCONVERTFUNPTR ConvertKeyFcn,
			     VTHTCOMPAREFUNPTR CompareFcn,
			     int initial_size));
ADDRESS VThtcreate V_P_((char *table_name,
			 VTHTCONVERTFUNPTR ConvertKeyFcn,
			 VTHTCOMPAREFUNPTR CompareFcn));
void VThtdestroy V_P_((ADDRESS htp,
		       VTHTFREEKEYFUNPTR FreeKey,
		       VTHTFREEVALFUNPTR FreeValue));
ADDRESS VThtget V_P_((char *ht_name));
ADDRESS VThthnget V_P_((register ADDRESS htp, int index));
char *VThnkey V_P_((ADDRESS hnp));
void VThnsetvalue V_P_((ADDRESS hnp, int *newvalue));
int *VThnvalue V_P_((ADDRESS hnp));
int VThtlen V_P_((ADDRESS htp));
ADDRESS VThtkeyfind V_P_((register ADDRESS htp,  char *searchkey));
ADDRESS VThtvalfind V_P_((ADDRESS htp,  register ADDRESS hnptr,
	 int *searchval));
int VThtcountval V_P_((ADDRESS htp, int *searchval));
ADDRESS VThthninsert V_P_((ADDRESS htptr,  char *newkey,
	 int *newvalue));
void VThthnremove V_P_((ADDRESS htp, ADDRESS hnp));
void VThttraverse V_P_((ADDRESS htp,
			VTHTTRAVERSEFUNPTR fcn,
			ADDRESS args));
void VThtstats V_P_((ADDRESS htp));
ULONG VThtstrconvert V_P_((register char *s));

/* VT/VTsymtab.c */
ADDRESS VTstcreate V_P_((char *table_name,
			 VTSTCOMPAREFUNPTR compare_fcn));
ADDRESS VTstsizecreate V_P_((char *table_name,
			     VTSTCOMPAREFUNPTR compare_fcn,
			     int initial_size));
void VTstdestroy V_P_((ADDRESS stp));
ADDRESS VTstget V_P_((char *st_name));
ADDRESS VTstsnget V_P_((register ADDRESS stp, int index));
char *VTsnkey V_P_((ADDRESS snp));
void VTsnsetvalue V_P_((ADDRESS snp, int *newvalue));
int *VTsnvalue V_P_((ADDRESS snp));
int VTstlen V_P_((ADDRESS stp));
ADDRESS VTstkeyfind V_P_((ADDRESS stp, char *searchkey));
ADDRESS VTstvalfind V_P_((ADDRESS stp,  register ADDRESS snp,
	 int *searchval));
int VTstcountval V_P_((ADDRESS stp, int *searchval));
ADDRESS VTstsninsert V_P_((register ADDRESS stp,  char *newkey,
	 int *newvalue));
void VTstsnremove V_P_((ADDRESS stp, ADDRESS snp));
void VTsttraverse V_P_((ADDRESS stp,  VTSTTRAVERSEFUNPTR fcn,
			ADDRESS args));
void VTsnprint V_P_((char *key, int *value));
void VThashPoolFree V_P_((void));


#ifdef __cplusplus
}
#endif /* __cplusplus */

#endif /* VTFUNDECL_H */
